var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import { useEffect, useRef } from 'react';
var PieChart = function (props) {
    var chartRef = useRef(null);
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    var serials = new Set();
    var xValues = new Set();
    if (props.chartData && Array.isArray(props.chartData)) {
        props.chartData.forEach(function (item) {
            var _a, _b, _c, _d;
            serials.add(item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
            xValues.add(item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
        });
    }
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            legend: {
                show: ((_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.legend) === null || _b === void 0 ? void 0 : _b.show) || false,
                orient: ((_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.legend) === null || _d === void 0 ? void 0 : _d.orient) || 'horizontal',
                align: ((_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.legend) === null || _f === void 0 ? void 0 : _f.align) || 'auto',
            },
            tooltip: {
                show: ((_h = (_g = props.setup.chart) === null || _g === void 0 ? void 0 : _g.tooltip) === null || _h === void 0 ? void 0 : _h.show) || false,
                trigger: ((_k = (_j = props.setup.chart) === null || _j === void 0 ? void 0 : _j.tooltip) === null || _k === void 0 ? void 0 : _k.trigger) || 'item',
                backgroundColor: ((_m = (_l = props.setup.chart) === null || _l === void 0 ? void 0 : _l.tooltip) === null || _m === void 0 ? void 0 : _m.backgroundColor) || '#000',
                borderRadius: ((_p = (_o = props.setup.chart) === null || _o === void 0 ? void 0 : _o.tooltip) === null || _p === void 0 ? void 0 : _p.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_s = (_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.tooltip) === null || _r === void 0 ? void 0 : _r.textStyle) === null || _s === void 0 ? void 0 : _s.fontSize) || 'normal',
                    color: ((_v = (_u = (_t = props.setup.chart) === null || _t === void 0 ? void 0 : _t.tooltip) === null || _u === void 0 ? void 0 : _u.textStyle) === null || _v === void 0 ? void 0 : _v.color) || '#fff',
                },
            },
            dataset: {
                source: __spreadArray([
                    __spreadArray([(_x = (_w = props.setup.chart) === null || _w === void 0 ? void 0 : _w.seri) === null || _x === void 0 ? void 0 : _x.field], Array.from(serials), true)
                ], Array.from(xValues).map(function (xValue) { return __spreadArray([
                    xValue
                ], Array.from(serials).map(function (serial) {
                    var _a, _b, _c, _d;
                    return ((_b = (_a = props.chartData) === null || _a === void 0 ? void 0 : _a.find(function (item) {
                        var _a, _b, _c, _d;
                        return item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field] === serial &&
                            item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field] === xValue;
                    })) === null || _b === void 0 ? void 0 : _b[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.y_axis) === null || _d === void 0 ? void 0 : _d.field]) || 0;
                }), true); }), true),
            },
            series: [
                {
                    type: 'pie',
                    radius: ['40%', '70%'],
                    avoidLabelOverlap: false,
                    padAngle: 5,
                    itemStyle: {
                        borderRadius: 10,
                        borderColor: '#fff',
                        borderWidth: 1,
                    },
                    label: {
                        show: false,
                        position: 'center',
                    },
                    emphasis: {
                        label: {
                            show: true,
                            fontSize: 20,
                            fontWeight: 'bold',
                        },
                    },
                    labelLine: {
                        show: false,
                    },
                },
            ],
        };
    };
    return _jsx(ReactECharts, { ref: chartRef, option: getOption() });
};
export default PieChart;
